<?php defined('SYSPATH') || die('No direct script access.');

/**
 * Class Model_Semesters
 *
 * @property int    ID
 * @property int    Num
 * @property int    Year
 * @property string Season
 */
class Model_Semesters extends Model
{
    private $data;

    public function __construct($data) {
        $this->data = $data;
        $this->data['Season'] = $this->data['Num'] == 1 ? 'autumn' : 'spring';
    }

    public function __isset($name) {
        return isset($this->data[$name]);
    }

    public function __get($name) {
        return $this->data[$name];
    }


    public static function load($id) {
        $data = DB::query(Database::SELECT, 'CALL `GetSemestersInfo`(:id)')
            ->param(':id', $id)->execute();

        if (!$data->count())
            throw new LogicException(Error::ID_IS_INCORRECT);

        return new self($data[0]);
    }

    public static function loadAll() {
        $res = DB::query(Database::SELECT, 'CALL `GetSemestersInfo`(0)')->execute();

        $list = [];
        foreach ($res as $semester)
            $list[$semester['ID']] = new self($semester);

        return $list;
    }

    public static function find($year, $semesterNum) {
        $data = DB::query(Database::SELECT, 'CALL `Semester_Find`(:year, :semesterNum)')
            ->param(':year', $year)
            ->param(':semesterNum', $semesterNum)
            ->execute();

        if (!$data->count() || $data[0] === -1)
            throw new LogicException(Error::ID_IS_INCORRECT);

        return new self($data[0]);
    }
}
